-- APELLIDOS _________________________________________ NOMBRE ______________
-- MAQUINA:  _______

type Escalar = Double
type Fila = [Escalar]
type Matriz = [Fila]

-----------
-- 1A) (1.5 puntos)
-----------
nula :: Int -> Int -> Matriz
nula n m = copy n (copy m 0.0)

copy n q = take n (repeat q)
  where repeat q = q : repeat q 

diagonal :: Matriz -> Fila
diagonal ( (x:xs):fs) = x : diagonal (map tail fs)
diagonal ([]:_) = []
diagonal  []     = []

-----------
-- 1B) (1.5 puntos)
-----------
-- Que computa la siguiente funcion
desconocida :: Matriz -> Matriz -> Matriz
desconocida = zipWith (zipWith (+))
-- Justificar la respuesta
-----------
-- 1C) (1.5 punto)
-----------
pliegaM :: (Fila -> a -> a) -> (Fila -> a) -> Matriz -> a
pliegaM f g [x] 	= g x
pliegaM f g (x:fs) 	= f x (pliegaM f g fs)

-----------
-- 1D) (2 puntos)
-----------
modulo :: Fila -> Escalar
modulo = foldr (*) 0.0

mayor_modulo :: Matriz -> Fila
mayor_modulo = pliegaM maxima id
maxima f1 f2 = if modulo f1 > modulo f2 then f1 else f2

m1 = [ [1.0,2.0,3.0], [3.1,0.2,5.2] ]

mapMatriz :: (Escalar -> Escalar) -> Matriz -> Matriz
mapMatriz f = pliegaM (\x y -> (map f x):y)  (\u -> [map f u])

m2 = mapMatriz ((-1.0)*) m1



---------------
--- EJERCICIO 2
--------------- 
-- 2A) (0.5 punto)
suma_digitos :: Int -> Int -> Int -> (Int,Int)
suma_digitos x y a = (s `div`10, s `mod` 10) where s=x+y+a

-----------
-- 2B) (2 puntos)
-----------
suma :: [Int] -> [Int] -> [Int]
suma xs ys = if af==0 then ds else af:ds
	where (af,ds) = foldr g (0,[]) (zip xs ys) 
              g (x,y) (a,ds) = (a',s:ds)
                   where (a',s)     = suma_digitos x y a

-----------
-- 2C) (1 punto)
-----------
suma' :: [Int] -> [Int] -> [Int]
suma' xs ys = suma xs' ys' where (xs',ys') = completa xs ys
completa xs ys 
    | dif>0       =   (xs,copy dif 0 ++ ys)
    | otherwise   =   (copy (-dif) 0 ++ xs,ys)
        where dif = length xs - length ys
	 
ds :: [Int]
ds = [0..9]     


puzzleApartadoD = [ (a,b,c,d) |  
	a<-ds,
	b<-ds\\[a],
	c<-ds\\[a,b],
	d<-ds\\[a,b,c],
	suma [a,b,c,d] [d,a,b,c] == [c,d,a,b] ]


(\\) :: Eq a => [a] -> [a] -> [a]
[]     \\ _		= []
(x:xs) \\ ys 
	| x `elem` ys 	= xs \\ ys
	| otherwise   	= x:(xs \\ ys)

generaPuzzles :: [ ([Int],[Int],[Int]) ]
generaPuzzles = [ ([a,b,c],ds,ds') |  
	a<-ds,
	b<-ds\\[a],
	c<-ds\\[a,b],
	let pers=permuta [a,b,c],ds<-pers,ds'<-pers,
	suma [a,b,c] ds == ds' ]

     	
permuta [x] = [ [x] ]
permuta (x:xs) = concat (map (x+:) (permuta xs))

x +: [] = [[x]]
x +: xs@(y:ys) = (x:xs) : map (y:) (x +: ys)

